Name:          w3c-libwww
Version:       5.4.1
Release:       0.20.20060206cvs
Summary:       HTTP library of common code
Group:         System Environment/Libraries
# See http://www.w3.org/Consortium/Legal/copyright-software.html
License:       W3C
URL:           http://www.w3.org/Library
#cvs -d :pserver:anonymous@dev.w3.org:/sources/public login
#after which you type "anonymous" as password.
#cvs -d :pserver:anonymous@dev.w3.org:/sources/public -z3 checkout libwww
Source0:       %{name}-20060206.tar.bz2
Patch0:        %{name}-configure.patch
Patch3:        %{name}-md5.patch
Patch4:        %{name}-makefile.patch
Patch10:       %{name}-%{version}-aix.patch

BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: libtool autoconf automake make
BuildRequires: expat-devel >= 2.2.0-1
BuildRequires: openssl-devel >= 1.0.2j-2
BuildRequires: zlib-devel >= 1.2.3-7
Requires: expat >= 2.2.0-1
Requires: openssl >= 1.0.2j-1
Requires: zlib >= 1.2.3-7

%define _libdir64 %{_prefix}/lib64

%description
Libwww is a general-purpose Web API written in C for Unix and Windows (Win32).
With a highly extensible and layered API, it can accommodate many different
types of applications including clients, robots, etc. The purpose of libwww
is to provide a highly optimized HTTP sample implementation as well as other
Internet protocols and to serve as a testbed for protocol experiments.


%package devel
Summary: Header files for programs that use libwww
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: expat-devel >= 2.2.0-1
Requires: openssl-devel >= 1.0.2j-2
Requires: zlib-devel >= 1.2.3-7

%description devel
Header files for libwww, which are available as public libraries.


%package apps
Summary: Applications built using Libwww web library
Group: Applications/Internet
Requires: %{name} = %{version}-%{release}
Requires: expat >= 2.2.0-1
Requires: openssl >= 1.0.2j-2
Requires: zlib >= 1.2.3-7

%description apps
Web applications built using Libwww: Robot, Command line tool, 
line mode browser.  The Robot can crawl web sites faster, and
with lower load, than any other web walker that we know of, 
due to its extensive pipelining and use of HTTP/1.1.

The command line tool (w3c) is very useful for manipulation of 
Web sites that implement more than just HTTP GET (e.g. PUT, POST, etc.).

The line mode browser is a minimal line mode web browser; 
often useful to convert to ascii text.


%prep
%setup -q -n libwww
export PATH=/opt/freeware/bin:$PATH
%patch0
%patch3
%patch4 -p1

%patch10

# we don't want the libwww version
rm -fr modules/expat

libtoolize -c -f
aclocal
autoheader
automake --add-missing
autoconf
echo timestamp > stamp-h.in

mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cp -r 32bit/* 64bit/


%build
export CC="xlc_r"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --enable-shared --disable-static \
    --enable-reentrant \
    --with-x \
    --with-zlib \
    --with-regex \
    --with-expat \
    --with-md5 \
    --with-dav \
    --with-ssl
gmake %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
./configure \
    --prefix=%{_prefix} \
    --enable-shared --disable-static \
    --enable-reentrant \
    --with-x \
    --with-zlib \
    --with-regex \
    --with-expat \
    --with-md5 \
    --with-dav \
    --with-ssl
gmake %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

cp wwwconf.h ${RPM_BUILD_ROOT}/%{_includedir}/w3c-libwww/
chmod 0644 ${RPM_BUILD_ROOT}/%{_includedir}/w3c-libwww/*

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
for i in md5 pics wwwapp wwwcache wwwcore wwwdav wwwdir wwwfile wwwftp \
             wwwgopher wwwhtml wwwhttp wwwinit wwwmime wwwmux wwwnews wwwssl \
             wwwstream wwwtelnet wwwtrans wwwutils wwwxml wwwzip ; do
  /usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib${i}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib${i}.so*
done

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/COPYRIGHT.html 32bit/LICENSE.html 32bit/PATCHES.html
%doc 32bit/README.html
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_datadir}/%{name}
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files apps
%defattr(-,root,system,-)
%{_bindir}/webbot*
%{_bindir}/w3c*
%{_bindir}/www*
/usr/bin/webbot*
/usr/bin/w3c*
/usr/bin/www*


%files devel
%defattr(-,root,system,-)
%{_bindir}/libwww-config*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_includedir}/*
/usr/bin/libwww-config*
/usr/lib/*.la
/usr/lib64/*.la
/usr/include/*


%changelog
* Mon Nov 21 2016 Michael Perzl <michael@perzl.org> - 5.4.1-0.20.20060206cvs
- recompiled against latest versions

* Fri Mar 04 2016 Michael Perzl <michael@perzl.org> - 5.4.1-0.19.20060206cvs
- recompiled against latest versions

* Tue Jan 11 2011 Michael Perzl <michael@perzl.org> - 5.4.1-0.18.20060206cvs
- first version for AIX V5.1 and higher
